#ifndef __BOILERPLATE_ACTIVATABLE_H__
#define __BOILERPLATE_ACTIVATABLE_H__

#include "boilerplate-application.h"

#include <glib-object.h>

G_BEGIN_DECLS

#define BOILERPLATE_TYPE_ACTIVATABLE (boilerplate_activatable_get_type ())

G_DECLARE_INTERFACE (BoilerplateActivatable, boilerplate_activatable, BOILERPLATE, ACTIVATABLE, GObject)

struct _BoilerplateActivatableInterface
{
	GTypeInterface parent;

    BoilerplateApplication *application;

	/* Virtual public methods */
	void (*activate) (BoilerplateActivatable *activatable);
	void (*deactivate) (BoilerplateActivatable *activatable);
    void (*update_state) (BoilerplateActivatable *activatable);
};

void
boilerplate_activatable_activate (BoilerplateActivatable *activatable);

void
boilerplate_activatable_deactivate (BoilerplateActivatable *activatable);

void
boilerplate_activatable_update_state (BoilerplateActivatable *activatable);

G_END_DECLS

#endif /* __BOILERPLATE_ACTIVATABLE_H__ */
